<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Pizza 365 | Drinks</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">

  <!-- Preloader -->    

  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <!-- Navbar Search -->
      <li class="nav-item">
        <a class="nav-link" data-widget="navbar-search" href="#" role="button">
          <i class="fas fa-search"></i>
        </a>
        <div class="navbar-search-block">
          <form class="form-inline">
            <div class="input-group input-group-sm">
              <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
              <div class="input-group-append">
                <button class="btn btn-navbar" type="submit">
                  <i class="fas fa-search"></i>
                </button>
                <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                  <i class="fas fa-times"></i>
                </button>
              </div>
            </div>
          </form>
        </div>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user panel (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Vũ Duy Dũng</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="indexDrink2.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="indexVoucher2.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Drinks</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Drink</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <h3 class="text-center text-primary">Quản trị menu</h3>
        <div class="jumbotron container">
            <div class="row form-group">
                <label for="" class="col-sm-3">Kích cỡ</label>
                <div class="col-sm-9">
                    <input id="inp-kich-co" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Đường kính</label>
                <div class="col-sm-9">
                    <input id="inp-duong-kinh" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Sườn</label>
                <div class="col-sm-9">
                    <input id="inp-suon" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Salad</label>
                <div class="col-sm-9">
                    <input id="inp-salad" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Số lượng nước</label>
                <div class="col-sm-9">
                    <input id="inp-so-luong-nuoc" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Thành tiền</label>
                <div class="col-sm-9">
                    <input id="inp-thanh-tien" type="number" class="form-control">
                </div>
            </div>

            
            <button id="btn-add" class="btn btn-success">Thêm mới</button>
            <button id="btn-update" class="btn btn-primary" style="display: none;">Cập nhật</button>
            <button id="btn-delete" class="btn btn-danger" style="display: none;">Xóa Menu</button>

        </div>

        <table id="table-menus" class="table table-bordered table-stripped table-hover">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Kích cỡ</th>
                    <th>Đường kính</th>
                    <th>Sườn</th>
                    <th>Salad</th>
                    <th>Số lượng nước</th>
                    <th>Thành tiền</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>
    </section>
    <!-- /.content -->
    <!-- Modal delete -->
<div class="modal fade" id="modal-delete" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <h5>Bạn có chắc chắn muốn xóa loại nước này?</h5>
        </div>
        <div class="modal-footer">
          <button id="btn-confirm" type="button" class="btn btn-primary">Xác nhận</button>
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
        </div>
      </div>
    </div>
  </div>
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
  var gTableMenus = $("#table-menus").DataTable({
      columns: [
          { data: "id"},
          { data: "kichCo"},
          { data: "duongKinh"},
          { data: "suon"},
          { data: "salad"},
          { data: "soLuongNuoc"},
          { data: "thanhTien"}
      ],
      columnDefs: [
          {
              targets: 0,
              render: function() {
                  return gStt++;
              }
          }
      ]
  });

  var gStt = 1;
  var gMenuId = null;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();

  // Thực thi sự kiện nhấn vào row trong datatable
  $("#table-menus").on("click", "tr", function() {
      onClickRowMenu(this);
  });

  // Thực thi sự kiện nhấn nút tạo mới menu 
  $("#btn-add").on("click", function(){
      onBtnAddNewClick();
  });

  // Thực thi sự kiện nhấn nút cập nhật menu 
  $("#btn-update").on("click", function(){
      onBtnUpdateClick();
  });

  // Thực thi sự kiện nhấn nút xóa menu 
  $("#btn-delete").on("click", function(){
      $("#modal-delete").modal("show");
  });

  // Thực thi sự kiện xác nhận xóa trong modal delete
  $("#btn-confirm").on("click", function() {
      onBtnDeleteClick();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
      callApiToLoadListMenu();
  }

  // Hàm sự kiện nhấn vào row menu
  function onClickRowMenu(paramRow) {
      var vDataRow = gTableMenus.row(paramRow).data();
      $("#inp-kich-co").val(vDataRow.kichCo);
      $("#inp-duong-kinh").prop("value", vDataRow.duongKinh);
      $("#inp-suon").val(vDataRow.suon);
      $("#inp-salad").val(vDataRow.salad);
      $("#inp-so-luong-nuoc").val(vDataRow.soLuongNuoc);
      $("#inp-thanh-tien").val(vDataRow.thanhTien);

      $("#btn-add").hide();
      $("#btn-update").show();
      $("#btn-delete").show();
      gMenuId = vDataRow.id;
  }

  // Hàm xử lý sự kiện nhấn nút thêm mới menu
  function onBtnAddNewClick() {
      var vMenu = {
          kichCo : "",
          duongKinh : "",
          suon : "",
          salad : "",
          soLuongNuoc : "",
          thanhTien : ""
      }

      getData(vMenu);
      var vValidate = validateData(vMenu);
      if(vValidate) {
          callApiToCreateNew(vMenu);
      }
  }

  // Hàm xử lý sự kiện nhấn nút sửa 1 menu
  function onBtnUpdateClick() {
      var vMenu = {
          kichCo : "",
          duongKinh : "",
          suon : "",
          salad : "",
          soLuongNuoc : "",
          thanhTien : ""
      }

      getData(vMenu);
      var vValidate = validateData(vMenu);
      if(vValidate) {
          callApiToUpdate(vMenu);
      }
  }

  // Hàm nhấn nút delete menu
  function onBtnDeleteClick() {
      $.ajax({
          type: "DELETE",
          url: "http://localhost:8080/menu/" + gMenuId,
          success: function(paramRes) {
              alert("Menu đã bị xóa!");
              callApiToLoadListMenu();
              resetForm();
              $("#modal-delete").modal("hide");
          },
          error: function(paramError) {
              console.log(paramError.status);
              alert("Xóa menu thất bại, vui lòng thử lại!");
              $("#modal-delete").modal("hide");
          }
      })
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  // Hàm gọi APi để load dữ liệu menu vào table
  function callApiToLoadListMenu() {
      $.ajax({
          type: "GET",
          url: "http://localhost:8080/menus",
          success: function(paramRes) {
              console.log(paramRes);
              loadDataToTable(paramRes);
          },
          error: function(paramError) {
              console.log(paramError.status);
          }
      });
  }

  // Hàm load dữ liệu vào table
  function loadDataToTable(paramMenuData) {
      gStt = 1;
      gTableMenus.clear();
      gTableMenus.rows.add(paramMenuData);
      gTableMenus.draw();
  }

  // Hàm format lại ngày tháng
  function formatDate(paramDate) {
      var vDate = paramDate.split("-");
      return vDate[2]+ "-" + vDate[1] + "-" + vDate[0];
  }

  // Hàm lấy dữ liệu từ form
  function getData(paramData) {
      paramData.kichCo = $("#inp-kich-co").val();
      paramData.duongKinh = $("#inp-duong-kinh").val();
      paramData.suon = $("#inp-suon").val();
      paramData.salad = $("#inp-salad").val();
      paramData.soLuongNuoc = $("#inp-so-luong-nuoc").val();
      paramData.thanhTien = $("#inp-thanh-tien").val();

  }

  // Hàm validate dữ liệu
  function validateData(paramData) {
      if(paramData.kichCo == "") {
          alert("Vui lòng nhập kích cỡ!");
          return false;
      }
      if(paramData.duongKinh == "") {
          alert("Nhập đường kính");
          return false;
      }
      
      if(paramData.suon == "") {
          alert("Nhập số lượng sườn");
          return false;
      }

      if(paramData.salad == "") {
          alert("Nhập lượng salad");
          return false;
      }

      if(paramData.soLuongNuoc == "") {
          alert("Nhập số lượng nước");
          return false;
      }

      if(paramData.thanhTien == "") {
          alert("Nhập giá tiền");
          return false;
      }
      return true;
  }

  // Hàm gọi api để thêm mới menu  
  function callApiToCreateNew(paramData) {
      $.ajax({
          type: "POST",
          url: "http://localhost:8080/menus",
          contentType: "application/json",
          data: JSON.stringify(paramData),
          success: function(paramRes) {
              alert("Tạo mới menu thành công!");
              resetForm();
              callApiToLoadListMenu();
          }, 
          error: function(paramError) {
              console.log(paramError.status);
          }
      });
  }

  // Hàm reset form menu
  function resetForm() {
      $("#inp-kich-co").val("");
      $("#inp-duong-kinh").val("");
      $("#inp-suon").val("");
      $("#inp-salad").val("");
      $("#inp-so-luong-nuoc").val("");
      $("#inp-thanh-tien").val("");

      $("#btn-add").show();
      $("#btn-update").hide();
      $("#btn-delete").hide();
  }

  // Hàm gọi API để sửa 1 menu
  function callApiToUpdate(paramData) {
      $.ajax({
          type: "PUT",
          url: "http://localhost:8080/menu/" + gMenuId,
          contentType: "application/json",
          data: JSON.stringify(paramData),
          success: function(paramRes) {
              alert("Cập nhật thành công!");
              resetForm();
              callApiToLoadListMenu();
          }, 
          error: function(paramError) {
              console.log(paramError.status);
          }
      });
  }


</script>
</body>
</html>
